#include "scene.h"
#include "m33.h"
#include "ppc.h"

#include <iostream>

using namespace std;

Scene *scene;

Scene::Scene() {

  gui = new GUI();
  gui->show();

  int u0 = 20;
  int v0 = 50;
  int sci = 2;
  int w = sci*320;
  int h = sci*240;
  fb = new FrameBuffer(u0, v0, w, h);
  fb->label("Framebuffer");
  fb->show();
  gui->uiw->position(fb->w+20+20, 50);
  float hfov = 45.0f;
  ppc = new PPC(hfov, w, h);
  tmsN = 2;
  tms = new TMesh[tmsN];
  V3 center(0.0f, 0.0f, -175.0f);
  float sl = 30.0f;
  tms[0].SetCube(center, sl);
  tms[1].Load("geometry/teapot1K.bin");
  AABB aabb = tms[1].GetAABB();
  float size0 = (aabb.corners[1]-aabb.corners[0]).Length();
  V3 tcenter = tms[1].GetCenter();
  tms[1].Translate(tcenter*-1.0f+center);
  float size1 = 170.0f;
  tms[1].ScaleAboutCenter(size1/size0);

  Render();

}

void Scene::Render() {

  fb->Set(0xFFFFFFFF);
  fb->SetZB(0.0f);

  for (int tmi = 0; tmi < tmsN; tmi++) {
    if (tmi == 0)
      continue;
    tms[tmi].Render(ppc, fb);
  }

  fb->redraw();

}

void Scene::DBG() {


  V3 center = tms[1].GetCenter();
  V3 newC(250.0f, 100.0f, 60.0f);
  V3 newVD = (center-newC).Normalized();
  V3 vinUP(0.0f, 1.0f, 0.0f);
  PPC ppc1;
  ppc->PositionAndOrient(newC, newVD, vinUP, ppc1);
  PPC ppc0(*ppc);
  int sN = 100;
  for (int si = 0; si < sN; si++) {
    float frac = (float) si / (float) sN;
    *ppc = ppc->Interpolate(&ppc0, &ppc1, frac);
    Render();
    Fl::check();
  }
  return;

  float tstep = 2.0f;
  ppc->TranslateLeft(tstep);
  Render();
  return;

  int stepsN = 360;
  V3 center1 = tms[0].GetCenter();
  for (int si = 0; si < stepsN; si++) {
    tms[0].RotateAboutArbitraryAxis(center1, V3(0.0f, 1.0f, 0.0f), 1.0f);
    Render();
    Fl::check();
  }
  return;

  float hfov = 45.0f;
  PPC ppc(hfov, fb->w, fb->h);
  
  float sl = 30.0f;
  V3 cvs[8];
  float nearz = -sl*2.0f;
  cvs[0] = V3(-sl/2.0f, sl/2.0f, nearz);
  cvs[1] = V3(-sl/2.0f, -sl/2.0f, nearz);
  cvs[2] = V3(sl/2.0f, -sl/2.0f, nearz);
  cvs[3] = V3(sl/2.0f, sl/2.0f, nearz);
  cvs[4] = V3(-sl/2.0f, sl/2.0f, nearz-sl);
  cvs[5] = V3(-sl/2.0f, -sl/2.0f, nearz-sl);
  cvs[6] = V3(sl/2.0f, -sl/2.0f, nearz-sl);
  cvs[7] = V3(sl/2.0f, sl/2.0f, nearz-sl);
  V3 projPs[8];
  V3 cols[8];
  cols[0] = cols[1] = cols[2] = cols[3] = V3(1.0f, 0.0f, 0.0f);
  cols[4] = cols[5] = cols[6] = cols[7] = V3(0.0f, 0.0f, 0.0f);
  for (int i = 0; i < 8; i++) {
    ppc.Project(cvs[i], projPs[i]);
  }
  for (int i = 0; i < 4; i++) {
    int _i = (i+1)%4;
    fb->DrawSegment(projPs[i], projPs[_i], cols[i], cols[_i]);
    fb->DrawSegment(projPs[4+i], projPs[4+_i], cols[4+i], cols[4+_i]);
    fb->DrawSegment(projPs[i], projPs[4+i], cols[i], cols[4+i]);
  }
  Render();
  return;


  return;
  V3 P(0.0f, 0.0f, -1.0f);
  V3 projP;
  bool projOK = ppc.Project(P, projP);
  return;

  M33 m;
  m[0] = V3(1.0f, 3.0f, -1.0f);
  m[1] = V3(10.0f, -31.0f, -11.0f);
  m[2] = V3(11.0f, 13.0f, 12.0f);
  M33 mi  = m.Invert();
  cerr << mi*m << endl << endl << m*mi;
  return;

  fb->Set(0xFF308080);
  Render();
  Fl::check();
  float scf = 10.5f;
  fb->Brighten(scf);
  Render();
  return;

  V3 P0(222.5f, 10.5f, 0.0f);
  V3 P1(122.5f, 410.5f, 0.0f);

  V3 c0;
  c0.SetFromColor(0xFF0000FF);
  V3 c1;
  c1.SetFromColor(0xFF00FF00);

  fb->DrawSegment(P0, P1, c0, c1);
  Render();
  return;

  unsigned int colss[2] = {0xFF000000, 0xFFFFFFFF};
  fb->SetAsChecker(32, colss);
  Render();
  return;

  for (int u = 0; u < fb->w; u++) {
    fb->Set(u, fb->h/2, 0xFF000000);
  }
  Render();
  return;

  cerr << "INFO: DBG" << endl;
  fb->Set(0xFF00FFFF);
  Render();

}

















